"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.GravityPreview = GravityPreview;
var _react = _interopRequireWildcard(require("react"));
var _GravitySdk = _interopRequireDefault(require("./GravitySdk"));
var _ForceUpdate = require("./ForceUpdate");
var _fixPreviewCode = require("../CodeGenPreview/fixPreviewCode");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function GravityPreview(_ref) {
  var code = _ref.code,
    height = _ref.height,
    refresh = _ref.refresh;
  var fixedCode = (0, _react.useMemo)(function () {
    return fixGravityCode(code, refresh);
  }, [code, refresh]);
  if (!code || !fixedCode) {
    return null;
  }
  console.log('GravityPreview', fixedCode);
  return /*#__PURE__*/_react["default"].createElement(_ForceUpdate.ForceUpdate, {
    watchKey: refresh
  }, /*#__PURE__*/_react["default"].createElement(_GravitySdk["default"], {
    code: fixedCode,
    width: "100%",
    height: height
  }));
}
function fixGravityCode(code, refresh) {
  if (!code) {
    return null;
  }
  var fixed = (0, _fixPreviewCode.fixPreviewCode)(code);
  Object.assign(fixed.modules, {
    '/src/html.js': {
      fpath: '/src/html.js',
      code: "function runScript(script){\n  const newScript = document.createElement('script');\n  newScript.innerHTML = script.innerHTML;\n  const src = script.getAttribute('src');\n  if (src) newScript.setAttribute('src', src);\n\n  document.head.appendChild(newScript);\n  document.head.removeChild(newScript);\n}\n\nfunction setHTMLWithScript(container, rawHTML){\n  container.innerHTML = rawHTML;\n  const scripts = container.querySelectorAll('script');\n  for (let script of scripts) {\n    runScript(script);\n  }\n} var html = window.BrowserFS.BFSRequire('fs').readFileSync('/~/src/index.html').toString();setHTMLWithScript(document.getElementById(\"riddleContainer\"), html);",
      entry: 1
    }
  });
  return fixed;
}